#include<iostream>
#include<stdlib.h>
#include<time.h>
#include<stdio.h>
#include<fstream>
#include<ctime>
#include "rlutil.h"

using namespace std;
void change(int A[16][16][2],int i,int j,int n);
void showAllZero(int A[16][16][2],int n,int x,int y,int &openedGridCount);
void show(int A[16][16][2],int i,int j,int n,int &openedGridCount);
void generateBoard(int A[16][16][2],int n);
void putMines(int A[16][16][2],int n);
void putNumbersInTheGrid(int A[16][16][2],int n);
void showboard(int A[16][16][2],int n,int &openedGridCount,int &flagCount);
void openMine(int A[16][16][2],int n);
void showAll(int A[16][16][2],int n,int &openedGridCount);
void flag(int A[16][16][2],int n,int &openedGridCount,int &flagCount);
void printTitle();
void easyScore(double newScore);
void hardScore(double newScore);
void showEasyScore();
void showHardScore();


//--------------------------------------------------//

int main()
{
int start,option,n,playAgain,openedGridCount,flagCount, numberMines;
double startTime, endTime, score;
int i,j,k,x,y,A[16][16][2];

/*A[16][16][2] is a three dimensional matrix. It can be thought of as two two
dimensional matrices.
A[16][16][0] contains a number which represents the number of mines around the cell.
A[16][16][1] can be equal to 0, 1, or 2.
    0 - The cell is closed
    1 - The cell is open
    2 - The cell has been flagged


*/

Game:
system("clear");
printTitle();
rlutil::setColor(13);
cout<<"\n\n\t\t\t\tMAIN MENU\n\n";
rlutil::setColor(10);
cout<<"\t\t\t1.Play Game\n\t\t\t2.Best Time\n\t\t\t3.How To Play\n\t\t\t4.About\n\t\t\t5.Quit\n\n";
rlutil::setColor(14);
cout<<"\t\t\tChoose your option:";
cin>>option;
switch(option)
{
    case 1:
        {
         system("clear");
         printTitle();// This function prints the title of the game, "MINESWEEPER" at the top of the screen
        }break;
    case 2:
        {
            rlutil::setColor(10);
            system("clear");
            printTitle();

            showEasyScore();
            showHardScore();


            rlutil::setColor(15);

         //access the file containing the best scores and print them
         //cout<<"The best time for easy is"<<endl;
         //cout<<"The best time for hard is"<<endl;
         //cout<<"Enter any number to go back to the main menu"<<endl;
         //cin<<option;
         goto Game;//Using a goto statement we go back to Game, the milestone.
        }
    case 3:
        {
          system("clear");
          printTitle();
          rlutil::setColor(13);
          cout<<"\n\n\t\t\t\tHOW TO PLAY\n\n\n";
          rlutil::setColor(10);
          cout<<"1. The object of the game:"<<endl;
          cout<<"       The objective of minesweeper is to open all the cells on the board."<<endl<<endl;
          cout<<"2. The board:"<<endl;
          cout<<"       The board consists of a certain number of cells. All the cells on the board contain a hidden value."<<endl;
          cout<<"       Some cells contain a mine. This is denoted by the letter 'M'. It will appear when you open a mine."<<endl;
          cout<<"       Other cells contain number values. Each cell is surrounded by a maximum of eight other cells."<<endl;
          cout<<"       The number in a certain cell represents the number of mines in the eight surrounding cells."<<endl<<endl;
          cout<<"3. Opening cells:"<<endl;
          cout<<"       To open a cell simply enter the number of the row and column of the cell that you want to open."<<endl<<endl;
          cout<<"       You will first be prompted to enter the number of the row. Remember that rows are numbered from top to bottom"<<endl;
          cout<<"       The numbers of the rows are displayed on the left edge of the board."<<endl<<endl;
          cout<<"       You will then be prompted to enter the number of the column. Remember that columns are numebred from left to right"<<endl;
          cout<<"       The numbers of the columns are displayed on the upper margin of the board."<<endl<<endl;
          cout<<"4. Flagging and unflagging cells: "<<endl;
          cout<<"       Certain cells can be flagged. That means that you will not be able to open certain cells as long as they are flagged"<<endl;
          cout<<"       To place a flag, enter the number 99 when you are prompted for the number of the row of the cell that you want to open(see point 3)."<<endl;
          cout<<"       Then, you will be prompted for the row and column for the cell that you want to flag."<<endl;
          cout<<"       A flagged cell will be marked by the letter 'F'. A flagged cell can be opened only after it is unflaggged."<<endl;
          cout<<"       To unflag a cell, enter the number 99 when you are prompted for the number of the row of the cell that you want to open(see point 3)"<<endl;
          cout<<"       You will then be prompted for the row and column of the cell that you want to unflag."<<endl;
          cout<<"       An unflagged cell can be operated upon like any regular cell"<<endl<<endl;
          cout<<"5. The game is won only when all the cells that do not contain mines are opened."<<endl<<endl;
          cout<<"   HAPPY GAMING"<<endl;
          rlutil::setColor(14);
          cout<<"\n\nPress 1 for Main Menu:";
          cin>>option;
          system("clear");
          goto Game;
        }
    case 4:
        {
          system("clear");
          printTitle();
          rlutil::setColor(13);
          cout<<"\n\n\t\t\t\tABOUT THE CREATORS\n\n\n";
          rlutil::setColor(10);
          cout<<"This game was created by the following people."<<endl<<endl<<endl<<endl;
          cout<<"1. Mohammad Imran Ansari. The chief coder."<<endl<<endl;
          cout<<"2. S Surya. The team leader."<<endl<<endl;
          cout<<"3. Rakesh Chandra Siyag"<<endl<<endl;
          cout<<"4. Raj Kumar Das"<<endl;
          rlutil::setColor(14);
          cout<<"\n\nEnter 1 for Main Menu:";
          cin>>option;
          system("clear");
          goto Game;
        }
    case 5:
        {
          system("clear");
          printTitle();
          rlutil::setColor(13);
          cout<<"\n\n\n\t\tAre you sure that you want to exit?\n\n";
          rlutil::setColor(10);
          cout<<"\t\t1.Yes\n\t\t2.No\n\n";
          rlutil::setColor(14);
          cout<<"\t\tEnter your option:";
          cin>>option;
          if(option==1)goto Exit;
          else
                {
                  system("clear");
                  goto Game;
                }
        }

    default:
        {
        goto Game;
        }

}
system("clear");
moreOptions:
printTitle();
rlutil::setColor(13);
cout<<"\n\n\t\t\t\tPLAY GAME\n\n";
rlutil::setColor(10);
cout<<"\t\t\t1.Easy\n\t\t\t2.Hard\n\t\t\t3.Main Menu\n\n";
rlutil::setColor(14);
cout<<"\t\t\tEnter Option:";
cin>>option;
if(option==1)
    {
    n=8;
    numberMines=10;
    }
else if(option==2)
    {
    numberMines=40;
    n=16;
    }
else if(option==3)
    {
        system("clear");
        goto Game;
    }
else
    {
     system("clear");
     goto moreOptions;
    }
Restart:
openedGridCount=0;
flagCount=0;
generateBoard(A,n);
putMines(A,n);
system("clear");

startTime = time(NULL);//Begin timing the game
Resume:
showboard(A,n,openedGridCount,flagCount);

do
    {
    //cout<<"Enter the location of block.(For more options give negative value of i)\ni=";
    row:
    rlutil::setColor(11);
    cout<<"For placing/removing a FLAG, enter 99 ";
    cout<<"for more options enter 55\n\n";
    cout<<"Enter the value of the row.\n\n";
    rlutil::setColor(14);
    cout<<"ROW: ";
    cin>>i;
    if(i==99){
        system("clear");
        flag(A,n,openedGridCount,flagCount);continue;
        }
    if(i==55)
        {
            rlutil::setColor(10);
            cout<<"\nMenu\n1.Resume\n2.Restart\n3.Main Menu\n4.Quit\n";
            rlutil::setColor(14);
            cout<<"Option:";
            cin>>i;
            if(i==1){system("clear");goto Resume;}
            if(i==2){system("clear");goto Restart;}
            if(i==3){system("clear");goto Game;}
            if(i==4){goto Exit;}
        }
     if(i<0)
        {
        rlutil::setColor(12);
        cout<<"\n\nROW cannot be negative. Please enter a valid value for ROW\n\n"<<endl;
        goto row;
        }
    if(i>=n&&(i!=99||i!=55))
        {
        rlutil::setColor(12);
        cout<<"\n\nInvalid input. Please enter a valid value for ROW\n\n"<<endl;
        goto row;
        }
    column:
    rlutil::setColor(11);
    cout<<"\nEnter the value of the column\n\n"<<endl;
    rlutil::setColor(14);
    cout<<"COLUMN: ";
    cin>>j;
    if(j<0||j>n)
        {
            rlutil::setColor(12);
            cout<<"\n\nInvalid input. Please enter a valid value for COLUMN\n\n";
            goto column;
        }
    if(A[i][j][1]==1 || A[i][j][1]==2)
        {
        system("clear");
        showboard(A,n,openedGridCount,flagCount);
        continue;
        }
    else if(A[i][j][0]==0)
        {
            system("clear");
            showAllZero(A,n,i,j,openedGridCount);
            showAll(A,n,openedGridCount);
            showboard(A,n,openedGridCount,flagCount);
        }
    else if(A[i][j][0]==-1)//Checking for losing condition
        {
            system("clear");
            openMine(A,n);
            showboard(A,n,openedGridCount,flagCount);
            rlutil::setColor(12);
            cout<<"\n\t\t\tYou have lost the Game\n\n"<<endl<<endl;
            rlutil::setColor(10);
            cout<<"To play again enter 1"<<endl<<"To go back to the main menu enter 2:";
            cin>>playAgain;
            if(playAgain==1)goto Restart;
            else goto Game;
        }
    else
        {
            A[i][j][1]=1;
            openedGridCount++;
            system("clear");
            showboard(A,n,openedGridCount,flagCount);
        }

    //Checking for winning condition
    if(openedGridCount==((n*n)-numberMines))
        {
            rlutil::setColor(10);
            cout<<"\n\t\t\tYou have won the Game\n\n";
            endTime = time(NULL);
            score = endTime-startTime;
            cout<<"\t\t\tYou finished the game in ";
            cout<<score<<" seconds"<<endl<<endl;
            if(n==8){
                easyScore(score);
            }

            else if(n==16){
                hardScore(score);
            }
            rlutil::setColor(10);
            cout<<"To play again enter 1\n To go to the main menu enter 2:";
            cin>>playAgain;
            if(playAgain==1)goto Restart;
            else goto Game;
        }

    }while(1);



Exit:
system("clear");
printTitle();
rlutil::setColor(14);
cout<<"\n\n\n\n\n\t\t\t\tHAPPY GAMING\n\n\n\n";
rlutil::setColor(15);
return 0;
}

//--------------------------------------------------//

void printTitle()
{
rlutil::setColor(121);
cout<<endl;
cout<<"     *   *  *****  *   *  ****  ****  *      *  ****  ****  ****  ****  ****      \n";
cout<<"     ** **    *    **  *  *     *     *      *  *     *     *  *  *     *   *     \n";
cout<<"     * * *    *    * * *  ****  ****  *  *   *  ****  ****  ****  ****  ****      \n";
cout<<"     *   *    *    *  **  *        *  * *  * *  *     *     *     *     * *       \n";
cout<<"     *   *  *****  *   *  ****  ****  *      *  ****  ****  *     ****  *   *     \n\n\n";
rlutil::setColor(15);

}

//--------------------------------------------------------

void generateBoard(int A[16][16][2],int n)
{
int i,j,k;
for(i=0;i<n;i++)for(j=0;j<n;j++)for(k=0;k<2;k++)A[i][j][k]=0;
}

//-------------------------------------------------------------

void putMines(int A[16][16][2],int n)
{
int i,j, iRow, iColumn, currentMine=0, mine, iSecret;
if(n==8){mine=10;}
else mine=40;
srand(time(NULL));
do{
    iRow=rand()%(n-1)+0;//Generates a random number between 0 and 7
    iColumn=rand()%(n-1)+0;//Generates a random number between 0 and 7
    if(A[iRow][iColumn][0]!=-1)
        {//If the column and row combination does not have a mine
        A[iRow][iColumn][0]=-1;//a mine is placed at that combination
        currentMine=currentMine+1;//The number of mines is incremented
        }
  }while(currentMine<mine);
putNumbersInTheGrid(A,n);
}

//---------------------------------------------------

void putNumbersInTheGrid(int A[16][16][2],int n)
{
int i,j;
for(i=0;i<n;i++)
{
    for(j=0;j<n;j++)
    {
        if(A[i][j][0]==-1)change(A,i,j,n);//Checking if there is mine or not.If there is mine then change the values in the blocks around it.
    }
}
}

//--------------------------------------------------------------

void change(int A[16][16][2],int i,int j,int n) //This function changes the number in the cells around the mines
{
int x,y;
    for(x=-1;x<=1;x++)//Dealing with the cells from left to right
    {
        for(y=-1;y<=1;y++)//dealing with the cells from top to bottom
        {
            if(A[i+x][j+y][0]!=-1 && i+x>=0 && i+x<n && j+y>=0 && j+y<n)
            {
                A[i+x][j+y][0]++;
            }
        }
    }
}

//-----------------------------------------------------

void showboard(int A[16][16][2],int n,int &openedGridCount,int &flagCount)
{
int x,y, columnCounter, rowCounter;
printTitle();
cout<<endl;
for(x=0;x<n;x++)
    {
        if(x==0){
                rlutil::setColor(6);
            cout<<"  | ";
            for(columnCounter=0; columnCounter<n; columnCounter++){
                if(columnCounter<10)
                {
                    rlutil::setColor(14);
                    cout<<columnCounter;
                    rlutil::setColor(6);
                    cout<<" | ";
                }
                else
                    {
                        rlutil::setColor(14);
                        cout<<columnCounter;
                        rlutil::setColor(6);
                        cout<<"| ";
                        }
                    }
            cout<<endl;
            }

        for(rowCounter=0; rowCounter<4*(n+1)-1;rowCounter++)
            {
            rlutil::setColor(6);
            cout<<"-";
            }
        cout<<endl;

        for(y=0;y<n;y++)
        {
            if(y==0&&x<10)
                {
                    rlutil::setColor(14);
                    cout<<x;
                    rlutil::setColor(6);
                    cout<<" |";
                }
            else if(y==0)
                {
                    rlutil::setColor(14);
                    cout<<x;
                    rlutil::setColor(6);
                    cout<<"|";
                }
            if(A[x][y][0]==-1 && A[x][y][1]==1)
                {
                    cout<<" ";
                    rlutil::setColor(12);
                    cout<<"M";
                    rlutil::setColor(6);
                    cout<<" |";
                }
            else if(A[x][y][1]==2)
                {
                     cout<<" ";
                     rlutil::setColor(15);
                     cout<<"F";
                     rlutil::setColor(6);
                     cout<<" |";
                }
            else if(A[x][y][1]==1)
                {
                    cout<<" ";
                    if(A[x][y][0]==0){rlutil::setColor(10);}
                    else if(A[x][y][0]>=3){rlutil::setColor(12);}
                    else if(A[x][y][0]==1){rlutil::setColor(13);}
                    else{rlutil::setColor(11);}
                    cout<<A[x][y][0];
                    rlutil::setColor(6);
                    cout<<" |";
                }
            else
                {
                    //rlutil::setColor(10);
                    cout<<" * ";
                    rlutil::setColor(6);
                    cout<<"|";
                }
        }
        cout<<endl;

    }
cout<<endl<<endl;
rlutil::setColor(14);
cout<<"\n"<<"Opened Grid="<<openedGridCount;
cout<<"\n"<<"Flag Placed="<<flagCount<<endl<<endl;
}

//------------------------------------------------

void showAllZero(int A[16][16][2],int n,int x,int y,int &openedGridCount)
{
  A[x][y][1]=1;//1 means show the block.
  openedGridCount++;
  if(x+1<n && A[x+1][y][0]==0 && A[x+1][y][1]==0 &&
A[x+1][y][1]!=2)showAllZero(A,n,x+1,y,openedGridCount);
  if(x-1>0 && A[x-1][y][0]==0 && A[x-1][y][1]==0 &&
A[x+1][y][1]!=2)showAllZero(A,n,x-1,y,openedGridCount);
  if(y+1<n && A[x][y+1][0]==0 && A[x][y+1][1]==0 &&
A[x+1][y][1]!=2)showAllZero(A,n,x,y+1,openedGridCount);
  if(y-1>0 && A[x][y-1][0]==0 && A[x][y-1][1]==0 &&
A[x+1][y][1]!=2)showAllZero(A,n,x,y-1,openedGridCount);
}

//-----------------------------------------------------------------

void showAll(int A[16][16][2],int n,int &openedGridCount)
{
int i,j;
for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
            {
               if(A[i][j][0]==0 && A[i][j][1]==1)show(A,i,j,n,openedGridCount);
            }
    }
}

//-----------------------------------------------------------

void flag(int A[16][16][2],int n,int &openedGridCount,int &flagCount)
{
    system("clear");
    showboard(A,n,openedGridCount,flagCount);
    int i,j,x,y;
    rlutil::setColor(10);
    cout<<"\nWhere do you want to place a flag\n\n";
    frow:
    rlutil::setColor(14);
    cout<<"ROW: ";
    cin>>i;
    if(i<0 || i>n)
    {
        rlutil::setColor(12);
        cout<<"\nInvalid Input. Please Give A Correct Value\n\n";
        goto frow;
    }
    fcol:
    rlutil::setColor(14);
    cout<<"\nCOLUMN: ";
    cin>>j;
    if(j<0 || j>n)
    {
        rlutil::setColor(12);
        cout<<"\nInvalid Input. Please Give A Correct Value\n";
        goto fcol;
    }
    if(A[i][j][1]==0){A[i][j][1]=2;flagCount++;}
    else if(A[i][j][1]==2){A[i][j][1]=0;flagCount--;}
    system("clear");
    showboard(A,n,openedGridCount,flagCount);
    return;
}

//-----------------------------------------------------

void openMine(int A[16][16][2],int n)
{
int i,j;
for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            if(A[i][j][0]==-1)A[i][j][1]=1;
        }
    }
}

//-----------------------------------------------

void show(int A[16][16][2],int i,int j,int n,int &openedGridCount)
{
int x,y;
for(x=-1;x<=1;x++)
    {
        for(y=-1;y<=1;y++)
        {
            if(i+x>=0 && i+x<n && j+y>=0 && j+y<n && A[i+x][j+y][1]==0)
            {
                A[i+x][j+y][1]++;openedGridCount++;
            }
        }
    }
}


void easyScore(double newScore){
    double score;
    string name, newName;

    ifstream infile;//creating an object of class ifstream. I for input.
    infile.open("easy_Score.txt");//opening a text file using a member function of object infile

    //check for error
    if(infile.fail())
    {
    cout<<"Error opening file\n";
    return;
    }

    infile >> name >> score;
    cout<<"Previous best score for easy level: "<<endl;
    cout<<"Name: "<<name<<endl;
    cout<<"Time: "<<score<<endl;
    infile.close();//Always close files that have been opened

    if(newScore<score){//Since a new score will only be added when a player takes less time to win the game
        cout<<endl;
        cout<<"Please enter your name: ";
        cin>>newName;
        cout<<endl;

        ofstream outfile;
        outfile.open("easyScore.txt");

        if(outfile.fail())
            {
                cout<<"Error opening file\n";
                return;
            }
        outfile<<newName<<endl<<newScore;
        outfile.close();


    }


return;
}
//-----------------------------------------------------------------------------

void hardScore(double newScore){
    double score;
    string name, newName;


    ifstream infile;//creating an object of class ifstream. I for input.
    infile.open("hardScore.txt");//opening a text file using a member function of object infile

    //check for error
    if(infile.fail())
    {
    cout<<"Error opening file";
    return;
    }

    infile >> name >> score;

    cout<<"Previous best score for hard level: "<<endl;
    cout<<"Name: "<<name<<endl;
    cout<<"Time: "<<score<<endl;
    infile.close();//Always close files that have been opened

    if(newScore<score){//Since a new score will only be added when a player takes less time to win the game
        cout<<endl;
        cout<<"Please enter your name: ";
        cin>>newName;
        cout<<endl;

        ofstream outfile;
        outfile.open("hardScore.txt");

        if(outfile.fail())
            {
                cout<<"Error opening file";
                return;
            }
        outfile<<newName<<endl<<newScore;
        outfile.close();


    }


return;
}

//--------------------------------------------------
void showEasyScore(){
    string name;
    double time;
    ifstream infile;
    infile.open("easy_Score.txt");

    if(infile.fail()){
        cout<<"Error in opening the file"<<endl;
        return;
        }
    infile >> name >> time;
    infile.close();
    cout<<"The best time for the easy level is "<<name<<" seconds by "<<time<<".\n\n\n\n";

    return;
}


//---------------------------------------------------


void showHardScore(){

    string name;
    double time;

    ifstream infile;
    infile.open("hardScore.txt");
    if(infile.fail()){
        cout<<"Error in opening the file";
        system("PAUSE");
        return;
    }

    infile >> name >> time;
    infile.close();
    cout<<"The best time for the hard level is "<< time<< " by " << name;
    return;
}
